$SAFE = 2
$CUR = '%0.2f'

# ***** Code Fixes *****
# Overrides some methods in the base class String.
class String
	alias orig_to_f to_f
	alias orig_to_i to_i
	alias string_format %
	def to_f
		delete(',').orig_to_f
	end
	def to_i
		delete(',').orig_to_i
	end
	def %(arg)
		if (arg.kind_of?(Array) or index('f') == nil)
			string_format(arg)
		else
			value = arg.to_f
			string_format(value < 0.0 ? value - 0.00000001 : value + 0.00000001)
		end
	end

end

# ***** Profile Classes *****
class Individual
 def first_name; ''; end
 def middle_initial; ''; end
 def last_name; ''; end
 def suffix; ''; end
 def address; ''; end
 def apartment_number; ''; end
 def city; ''; end
 def state; ''; end
 def zip; ''; end
 def phone; ''; end
 def work_phone; ''; end
 def mobile_phone; ''; end
 def fax; ''; end
 def ssn; ''; end
 def occupation; ''; end
 def county; ''; end
 def school_code; ''; end
 def email; ''; end
 def blind; ''; end
 def sixty_five_plus; ''; end
 def spouse_first_name; ''; end
 def spouse_middle_initial; ''; end
 def spouse_last_name; ''; end
 def spouse_suffix; ''; end
 def spouse_address; ''; end
 def spouse_apartment_number; ''; end
 def spouse_city; ''; end
 def spouse_state; ''; end
 def spouse_zip; ''; end
 def spouse_phone; ''; end
 def spouse_work_phone; ''; end
 def spouse_mobile_phone; ''; end
 def spouse_fax; ''; end
 def spouse_ssn; ''; end
 def spouse_occupation; ''; end
 def spouse_county; ''; end
 def spouse_school_code; ''; end
 def spouse_email; ''; end
 def spouse_blind; ''; end
 def spouse_65_plus; ''; end
 def single; ''; end
 def married_joint; ''; end
 def married_separate; ''; end
 def head_of_household; ''; end
 def widow_widower; ''; end
 def direct_deposit_checking; ''; end
 def direct_deposit_savings; ''; end
 def routing_number; ''; end
 def account_number; ''; end
 def dependent1_first_name; ''; end
 def dependent1_last_name; ''; end
 def dependent1_ssn; ''; end
 def dependent1_relationship; ''; end
 def dependent1_dob; ''; end
 def dependent2_first_name; ''; end
 def dependent2_last_name; ''; end
 def dependent2_ssn; ''; end
 def dependent2_relationship; ''; end
 def dependent2_dob; ''; end
 def dependent3_first_name; ''; end
 def dependent3_last_name; ''; end
 def dependent3_ssn; ''; end
 def dependent3_relationship; ''; end
 def dependent3_dob; ''; end
 def dependent4_first_name; ''; end
 def dependent4_last_name; ''; end
 def dependent4_ssn; ''; end
 def dependent4_relationship; ''; end
 def dependent4_dob; ''; end
 def dependent5_first_name; ''; end
 def dependent5_last_name; ''; end
 def dependent5_ssn; ''; end
 def dependent5_relationship; ''; end
 def dependent5_dob; ''; end
 def dependent6_first_name; ''; end
 def dependent6_last_name; ''; end
 def dependent6_ssn; ''; end
 def dependent6_relationship; ''; end
 def dependent6_dob; ''; end
 def business_name; ''; end
 def business_address; ''; end
 def business_address2; ''; end
 def business_city; ''; end
 def business_state; ''; end
 def business_zip; ''; end
 def fein; ''; end
 def business_phone; ''; end
 def business_fax; ''; end
 def business_email; ''; end
end

class Preparer
 def first_name; ''; end
 def middle_initial; ''; end
 def last_name; ''; end
 def firm_name; ''; end
 def address; ''; end
 def city; ''; end
 def state; ''; end
 def zip; ''; end
 def phone; ''; end
 def work_phone; ''; end
 def mobile_phone; ''; end
 def fax; ''; end
 def email; ''; end
 def fein; ''; end
 def ptin; ''; end
 def ssn; ''; end
 def self_employed; ''; end
end

class Entity
 def name; ''; end
 def address; ''; end
 def address2; ''; end
 def city; ''; end
 def state; ''; end
 def zip; ''; end
 def phone; ''; end
 def fax; ''; end
 def email; ''; end
 def fein; ''; end
 def state_id; ''; end
 def date_started; ''; end
 def state_of_incorporation; ''; end
 def naics_code; ''; end
 def principal_activity; ''; end
 def contact_name; ''; end
 def contact_title; ''; end
 def contact_phone; ''; end
 def estate_name; ''; end
 def estate_ssn; ''; end
 def estate_dod; ''; end
 def agent_first_name; ''; end
 def agent_middle_initial; ''; end
 def agent_last_name; ''; end
 def agent_business_name; ''; end
 def agent_address; ''; end
 def agent_city; ''; end
 def agent_state; ''; end
 def agent_zip; ''; end
 def agent_phone; ''; end
end

class Fiduciary
 def first_name_and_mi; ''; end
 def last_name; ''; end
 def title; ''; end
 def address; ''; end
 def city; ''; end
 def state; ''; end
 def zip; ''; end
 def phone; ''; end
 def ssn; ''; end
 def estate_name; ''; end
 def ein; ''; end
 def entity_creation_date; ''; end
 def entity_type_decendents; ''; end
 def entity_type_simple; ''; end
 def entity_type_complex; ''; end
 def entity_type_disability; ''; end
 def entity_type_esbt; ''; end
 def entity_type_grantor; ''; end
 def entity_type_bankruptcy_ch7; ''; end
 def entity_type_bankruptcy_ch11; ''; end
 def entity_type_pooled_income; ''; end
 def decedent_first_name_and_mi; ''; end
 def decedent_last_name; ''; end
 def decedent_address; ''; end
 def decedent_city; ''; end
 def decedent_state; ''; end
 def decedent_zip; ''; end
 def decedent_phone; ''; end
 def decedent_ssn; ''; end
 def decedent_dob; ''; end
 def decedent_dod; ''; end
end

class Equifax
def account_name; ''; end
def unemp_tax_yes; ''; end
def unemp_tax_no; ''; end
def local_wh_tax_yes; ''; end
def local_wh_tax_no; ''; end
def wh_tax_yes; ''; end
def wh_tax_no; ''; end
def emp_tax_consult_yes; ''; end
def emp_tax_consult_no; ''; end
def open_new_business; ''; end
def exist_entity_new_in_state; ''; end
def acquire_exist_business; ''; end
def reopen_inactiv_business; ''; end
def change_owner_type_entity; ''; end
def name_change; ''; end
def acct_closures; ''; end
def other_checkbox; ''; end
def other_list; ''; end
def succ_business_name; ''; end
def succ_trade_dba; ''; end
def succ_fein; ''; end
def succ_phone; ''; end
def succ_corp_address; ''; end
def succ_corp_address2; ''; end
def succ_corp_city; ''; end
def succ_corp_state; ''; end
def succ_corp_zip; ''; end
def succ_mailing_address; ''; end
def succ_mailing_address2; ''; end
def succ_mailing_city; ''; end
def succ_mailing_state; ''; end
def succ_mailing_zip; ''; end
def succ_contact_name; ''; end
def succ_contact_title; ''; end
def succ_contact_phone; ''; end
def succ_contact_fax; ''; end
def succ_contact_email; ''; end
def succ_entity_type_corp_public; ''; end
def succ_entity_type_corp_private; ''; end
def succ_entity_type_partnership; ''; end
def succ_entity_type_ltd_partnership; ''; end
def succ_entity_type_scorp; ''; end
def succ_entity_type_other_checkbox; ''; end
def succ_entity_type_other_list; ''; end
def succ_entity_type_llc; ''; end
def succ_entity_type_taxed_as_corp; ''; end
def succ_entity_type_taxed_as_partnership; ''; end
def succ_entity_type_disregarded_entity; ''; end
def succ_entity_type_disregarded_entity_member_name; ''; end
def succ_entity_type_disregarded_entity_member_fein; ''; end
def succ_entity_type_sole_proprietor; ''; end
def succ_state_of_incorporation; ''; end
def succ_date_started; ''; end
def succ_fiscal_yr_end_date; ''; end
def succ_acctng_method_cash; ''; end
def succ_acctng_method_accrual; ''; end
def succ_first_day_of_employment; ''; end
def succ_first_payroll_date; ''; end
def succ_nature_of_business_retail; ''; end
def succ_nature_of_business_wholesale; ''; end
def succ_nature_of_business_manufacturing; ''; end
def succ_nature_of_business_service; ''; end
def succ_nature_of_business_staffing_temp; ''; end
def succ_nature_of_business_prof_emp_org; ''; end
def succ_nature_of_business_other_checkbox; ''; end
def succ_nature_of_business_other_list; ''; end
def succ_business_activity_description; ''; end
def succ_naics_code; ''; end
def succ_501_c_3_exempt_yes; ''; end
def succ_501_c_3_exempt_no; ''; end
def succ_futa_yes; ''; end
def succ_futa_no; ''; end
def succ_futa_date_first_liability; ''; end
def succ_psp_na; ''; end
def succ_psp_name; ''; end
def succ_psp_contact_name; ''; end
def succ_psp_phone; ''; end
def succ_psp_address; ''; end
def succ_psp_city; ''; end
def succ_psp_state; ''; end
def succ_psp_zip; ''; end
def succ_bank_name; ''; end
def succ_bank_address; ''; end
def succ_bank_city; ''; end
def succ_bank_state; ''; end
def succ_bank_zip; ''; end
def succ_bank_phone; ''; end
def succ_bank_acct_number; ''; end
def succ_empl_other_states_yes; ''; end
def succ_empl_other_states_no; ''; end
def succ_empl_other_states_multiple; ''; end
def succ_break_in_employment_yes; ''; end
def succ_break_in_employment_no; ''; end
def succ_total_payroll_quarter; ''; end
def succ_total_payroll_year; ''; end
def succ_20th_wk_date_emp; ''; end
def succ_parent_company_name; ''; end
def succ_parent_company_fein; ''; end
def succ_officer1_name; ''; end
def succ_officer1_title; ''; end
def succ_officer1_ssn_ein; ''; end
def succ_officer1_address; ''; end
def succ_officer1_city; ''; end
def succ_officer1_state; ''; end
def succ_officer1_zip; ''; end
def succ_officer1_dob; ''; end
def succ_officer1_date_of_appt; ''; end
def succ_officer2_name; ''; end
def succ_officer2_title; ''; end
def succ_officer2_ssn_ein; ''; end
def succ_officer2_address; ''; end
def succ_officer2_city; ''; end
def succ_officer2_state; ''; end
def succ_officer2_zip; ''; end
def succ_officer2_dob; ''; end
def succ_officer2_date_of_appt; ''; end
def succ_officer3_name; ''; end
def succ_officer3_title; ''; end
def succ_officer3_ssn_ein; ''; end
def succ_officer3_address; ''; end
def succ_officer3_city; ''; end
def succ_officer3_state; ''; end
def succ_officer3_zip; ''; end
def succ_officer3_dob; ''; end
def succ_officer3_date_of_appt; ''; end
def pred_name; ''; end
def pred_dba; ''; end
def pred_fein; ''; end
def pred_phone; ''; end
def pred_corp_address; ''; end
def pred_corp_address2; ''; end
def pred_corp_city; ''; end
def pred_corp_state; ''; end
def pred_corp_zip; ''; end
def pred_contact_name; ''; end
def pred_contact_phone; ''; end
def pred_contact_mailing_address; ''; end
def pred_contact_mailing_address2; ''; end
def pred_contact_mailing_city; ''; end
def pred_contact_mailing_state; ''; end
def pred_contact_mailing_zip; ''; end
def pred_transaction_date; ''; end
def pred_operating_at_time_of_purchase_yes; ''; end
def pred_operating_at_time_of_purchase_no; ''; end
def pred_transaction_type_asset_purchase; ''; end
def pred_transaction_type_stock_purchase; ''; end
def pred_transaction_type_company_reorg; ''; end
def pred_transaction_type_salutory_merger; ''; end
def pred_transaction_type_other_checkbox; ''; end
def pred_transaction_type_other_list; ''; end
def pred_transaction_type_employee_reassignment; ''; end
def pred_transaction_type_bankruptcy_acq; ''; end
def pred_transaction_type_entity_conversion; ''; end
def pred_acq_all_employment; ''; end
def pred_acq_partial_employment; ''; end
def pred_emp_agency_yes; ''; end
def pred_emp_agency_no; ''; end
def pred_business_description; ''; end
def pred_succ_commonly_owned_yes; ''; end
def pred_succ_commonly_owned_no; ''; end
def pred_succ_commonly_owned_percent; ''; end
def pred_succ_relationship_described; ''; end
def pred_acquired_assets_acct_rec; ''; end
def pred_acquired_assets_machinery_equip; ''; end
def pred_acquired_assets_furniture_fixtures; ''; end
def pred_acquired_assets_goodwill; ''; end
def pred_acquired_assets_buildings; ''; end
def pred_acquired_assets_stock; ''; end
def pred_acquired_assets_other_real_prop_leases; ''; end
def pred_acquired_assets_customer_lists; ''; end
def pred_acquired_assets_employees; ''; end
def pred_acquired_assets_inventories; ''; end
def pred_will_report_wages_yes; ''; end
def pred_will_report_wages_no; ''; end
def pred_last_date_of_emp; ''; end
def pred_date_of_last_payroll; ''; end
def pred_parent_company_name; ''; end
def pred_parent_company_fein; ''; end
def pred_officer1_name; ''; end
def pred_officer1_title; ''; end
def pred_officer1_ssn_ein; ''; end
def pred_officer1_address; ''; end
def pred_officer1_city; ''; end
def pred_officer1_state; ''; end
def pred_officer1_zip; ''; end
def pred_officer1_dob; ''; end
def pred_officer1_date_of_appt; ''; end
def pred_officer2_name; ''; end
def pred_officer2_title; ''; end
def pred_officer2_ssn_ein; ''; end
def pred_officer2_address; ''; end
def pred_officer2_city; ''; end
def pred_officer2_state; ''; end
def pred_officer2_zip; ''; end
def pred_officer2_dob; ''; end
def pred_officer2_date_of_appt; ''; end
def pred_officer3_name; ''; end
def pred_officer3_title; ''; end
def pred_officer3_ssn_ein; ''; end
def pred_officer3_address; ''; end
def pred_officer3_city; ''; end
def pred_officer3_state; ''; end
def pred_officer3_zip; ''; end
def pred_officer3_dob; ''; end
def pred_officer3_date_of_appt; ''; end
def AK_pred_unemp_acct_number; ''; end
def AK_succ_unemp_acct_number; ''; end
def AK_pred_wh_acct_number; ''; end
def AK_address1; ''; end
def AK_city; ''; end
def AK_zip; ''; end
def AK_number_emp_transferred; ''; end
def AK_number_emp_retained; ''; end
def AK_est_mo_wages; ''; end
def AK_est_state_wh_tax; ''; end
def AL_pred_unemp_acct_number; ''; end
def AL_succ_unemp_acct_number; ''; end
def AL_pred_wh_acct_number; ''; end
def AL_address1; ''; end
def AL_city; ''; end
def AL_zip; ''; end
def AL_number_emp_transferred; ''; end
def AL_number_emp_retained; ''; end
def AL_est_mo_wages; ''; end
def AL_est_state_wh_tax; ''; end
def AR_pred_unemp_acct_number; ''; end
def AR_succ_unemp_acct_number; ''; end
def AR_pred_wh_acct_number; ''; end
def AR_address1; ''; end
def AR_city; ''; end
def AR_zip; ''; end
def AR_number_emp_transferred; ''; end
def AR_number_emp_retained; ''; end
def AR_est_mo_wages; ''; end
def AR_est_state_wh_tax; ''; end
def AZ_pred_unemp_acct_number; ''; end
def AZ_succ_unemp_acct_number; ''; end
def AZ_pred_wh_acct_number; ''; end
def AZ_address1; ''; end
def AZ_city; ''; end
def AZ_zip; ''; end
def AZ_number_emp_transferred; ''; end
def AZ_number_emp_retained; ''; end
def AZ_est_mo_wages; ''; end
def AZ_est_state_wh_tax; ''; end
def CA_pred_unemp_acct_number; ''; end
def CA_succ_unemp_acct_number; ''; end
def CA_pred_wh_acct_number; ''; end
def CA_address1; ''; end
def CA_city; ''; end
def CA_zip; ''; end
def CA_number_emp_transferred; ''; end
def CA_number_emp_retained; ''; end
def CA_est_mo_wages; ''; end
def CA_est_state_wh_tax; ''; end
def CO_pred_unemp_acct_number; ''; end
def CO_succ_unemp_acct_number; ''; end
def CO_pred_wh_acct_number; ''; end
def CO_address1; ''; end
def CO_city; ''; end
def CO_zip; ''; end
def CO_number_emp_transferred; ''; end
def CO_number_emp_retained; ''; end
def CO_est_mo_wages; ''; end
def CO_est_state_wh_tax; ''; end
def CT_pred_unemp_acct_number; ''; end
def CT_succ_unemp_acct_number; ''; end
def CT_pred_wh_acct_number; ''; end
def CT_address1; ''; end
def CT_city; ''; end
def CT_zip; ''; end
def CT_number_emp_transferred; ''; end
def CT_number_emp_retained; ''; end
def CT_est_mo_wages; ''; end
def CT_est_state_wh_tax; ''; end
def DC_pred_unemp_acct_number; ''; end
def DC_succ_unemp_acct_number; ''; end
def DC_pred_wh_acct_number; ''; end
def DC_address1; ''; end
def DC_city; ''; end
def DC_zip; ''; end
def DC_number_emp_transferred; ''; end
def DC_number_emp_retained; ''; end
def DC_est_mo_wages; ''; end
def DC_est_state_wh_tax; ''; end
def DE_pred_unemp_acct_number; ''; end
def DE_succ_unemp_acct_number; ''; end
def DE_pred_wh_acct_number; ''; end
def DE_address1; ''; end
def DE_city; ''; end
def DE_zip; ''; end
def DE_number_emp_transferred; ''; end
def DE_number_emp_retained; ''; end
def DE_est_mo_wages; ''; end
def DE_est_state_wh_tax; ''; end
def FL_pred_unemp_acct_number; ''; end
def FL_succ_unemp_acct_number; ''; end
def FL_pred_wh_acct_number; ''; end
def FL_address1; ''; end
def FL_city; ''; end
def FL_zip; ''; end
def FL_number_emp_transferred; ''; end
def FL_number_emp_retained; ''; end
def FL_est_mo_wages; ''; end
def FL_est_state_wh_tax; ''; end
def GA_pred_unemp_acct_number; ''; end
def GA_succ_unemp_acct_number; ''; end
def GA_pred_wh_acct_number; ''; end
def GA_address1; ''; end
def GA_city; ''; end
def GA_zip; ''; end
def GA_number_emp_transferred; ''; end
def GA_number_emp_retained; ''; end
def GA_est_mo_wages; ''; end
def GA_est_state_wh_tax; ''; end
def HI_pred_unemp_acct_number; ''; end
def HI_succ_unemp_acct_number; ''; end
def HI_pred_wh_acct_number; ''; end
def HI_address1; ''; end
def HI_city; ''; end
def HI_zip; ''; end
def HI_number_emp_transferred; ''; end
def HI_number_emp_retained; ''; end
def HI_est_mo_wages; ''; end
def HI_est_state_wh_tax; ''; end
def IA_pred_unemp_acct_number; ''; end
def IA_succ_unemp_acct_number; ''; end
def IA_pred_wh_acct_number; ''; end
def IA_address1; ''; end
def IA_city; ''; end
def IA_zip; ''; end
def IA_number_emp_transferred; ''; end
def IA_number_emp_retained; ''; end
def IA_est_mo_wages; ''; end
def IA_est_state_wh_tax; ''; end
def ID_pred_unemp_acct_number; ''; end
def ID_succ_unemp_acct_number; ''; end
def ID_pred_wh_acct_number; ''; end
def ID_address1; ''; end
def ID_city; ''; end
def ID_zip; ''; end
def ID_number_emp_transferred; ''; end
def ID_number_emp_retained; ''; end
def ID_est_mo_wages; ''; end
def ID_est_state_wh_tax; ''; end
def IL_pred_unemp_acct_number; ''; end
def IL_succ_unemp_acct_number; ''; end
def IL_pred_wh_acct_number; ''; end
def IL_address1; ''; end
def IL_city; ''; end
def IL_zip; ''; end
def IL_number_emp_transferred; ''; end
def IL_number_emp_retained; ''; end
def IL_est_mo_wages; ''; end
def IL_est_state_wh_tax; ''; end
def IN_pred_unemp_acct_number; ''; end
def IN_succ_unemp_acct_number; ''; end
def IN_pred_wh_acct_number; ''; end
def IN_address1; ''; end
def IN_city; ''; end
def IN_zip; ''; end
def IN_number_emp_transferred; ''; end
def IN_number_emp_retained; ''; end
def IN_est_mo_wages; ''; end
def IN_est_state_wh_tax; ''; end
def KS_pred_unemp_acct_number; ''; end
def KS_succ_unemp_acct_number; ''; end
def KS_pred_wh_acct_number; ''; end
def KS_address1; ''; end
def KS_city; ''; end
def KS_zip; ''; end
def KS_number_emp_transferred; ''; end
def KS_number_emp_retained; ''; end
def KS_est_mo_wages; ''; end
def KS_est_state_wh_tax; ''; end
def KY_pred_unemp_acct_number; ''; end
def KY_succ_unemp_acct_number; ''; end
def KY_pred_wh_acct_number; ''; end
def KY_address1; ''; end
def KY_city; ''; end
def KY_zip; ''; end
def KY_number_emp_transferred; ''; end
def KY_number_emp_retained; ''; end
def KY_est_mo_wages; ''; end
def KY_est_state_wh_tax; ''; end
def LA_pred_unemp_acct_number; ''; end
def LA_succ_unemp_acct_number; ''; end
def LA_pred_wh_acct_number; ''; end
def LA_address1; ''; end
def LA_city; ''; end
def LA_zip; ''; end
def LA_number_emp_transferred; ''; end
def LA_number_emp_retained; ''; end
def LA_est_mo_wages; ''; end
def LA_est_state_wh_tax; ''; end
def MA_pred_unemp_acct_number; ''; end
def MA_succ_unemp_acct_number; ''; end
def MA_pred_wh_acct_number; ''; end
def MA_address1; ''; end
def MA_city; ''; end
def MA_zip; ''; end
def MA_number_emp_transferred; ''; end
def MA_number_emp_retained; ''; end
def MA_est_mo_wages; ''; end
def MA_est_state_wh_tax; ''; end
def MD_pred_unemp_acct_number; ''; end
def MD_succ_unemp_acct_number; ''; end
def MD_pred_wh_acct_number; ''; end
def MD_address1; ''; end
def MD_city; ''; end
def MD_zip; ''; end
def MD_number_emp_transferred; ''; end
def MD_number_emp_retained; ''; end
def MD_est_mo_wages; ''; end
def MD_est_state_wh_tax; ''; end
def ME_pred_unemp_acct_number; ''; end
def ME_succ_unemp_acct_number; ''; end
def ME_pred_wh_acct_number; ''; end
def ME_address1; ''; end
def ME_city; ''; end
def ME_zip; ''; end
def ME_number_emp_transferred; ''; end
def ME_number_emp_retained; ''; end
def ME_est_mo_wages; ''; end
def ME_est_state_wh_tax; ''; end
def MI_pred_unemp_acct_number; ''; end
def MI_succ_unemp_acct_number; ''; end
def MI_pred_wh_acct_number; ''; end
def MI_address1; ''; end
def MI_city; ''; end
def MI_zip; ''; end
def MI_number_emp_transferred; ''; end
def MI_number_emp_retained; ''; end
def MI_est_mo_wages; ''; end
def MI_est_state_wh_tax; ''; end
def MN_pred_unemp_acct_number; ''; end
def MN_succ_unemp_acct_number; ''; end
def MN_pred_wh_acct_number; ''; end
def MN_address1; ''; end
def MN_city; ''; end
def MN_zip; ''; end
def MN_number_emp_transferred; ''; end
def MN_number_emp_retained; ''; end
def MN_est_mo_wages; ''; end
def MN_est_state_wh_tax; ''; end
def MO_pred_unemp_acct_number; ''; end
def MO_succ_unemp_acct_number; ''; end
def MO_pred_wh_acct_number; ''; end
def MO_address1; ''; end
def MO_city; ''; end
def MO_zip; ''; end
def MO_number_emp_transferred; ''; end
def MO_number_emp_retained; ''; end
def MO_est_mo_wages; ''; end
def MO_est_state_wh_tax; ''; end
def MS_pred_unemp_acct_number; ''; end
def MS_succ_unemp_acct_number; ''; end
def MS_pred_wh_acct_number; ''; end
def MS_address1; ''; end
def MS_city; ''; end
def MS_zip; ''; end
def MS_number_emp_transferred; ''; end
def MS_number_emp_retained; ''; end
def MS_est_mo_wages; ''; end
def MS_est_state_wh_tax; ''; end
def MT_pred_unemp_acct_number; ''; end
def MT_succ_unemp_acct_number; ''; end
def MT_pred_wh_acct_number; ''; end
def MT_address1; ''; end
def MT_city; ''; end
def MT_zip; ''; end
def MT_number_emp_transferred; ''; end
def MT_number_emp_retained; ''; end
def MT_est_mo_wages; ''; end
def MT_est_state_wh_tax; ''; end
def NC_pred_unemp_acct_number; ''; end
def NC_succ_unemp_acct_number; ''; end
def NC_pred_wh_acct_number; ''; end
def NC_address1; ''; end
def NC_city; ''; end
def NC_zip; ''; end
def NC_number_emp_transferred; ''; end
def NC_number_emp_retained; ''; end
def NC_est_mo_wages; ''; end
def NC_est_state_wh_tax; ''; end
def ND_pred_unemp_acct_number; ''; end
def ND_succ_unemp_acct_number; ''; end
def ND_pred_wh_acct_number; ''; end
def ND_address1; ''; end
def ND_city; ''; end
def ND_zip; ''; end
def ND_number_emp_transferred; ''; end
def ND_number_emp_retained; ''; end
def ND_est_mo_wages; ''; end
def ND_est_state_wh_tax; ''; end
def NE_pred_unemp_acct_number; ''; end
def NE_succ_unemp_acct_number; ''; end
def NE_pred_wh_acct_number; ''; end
def NE_address1; ''; end
def NE_city; ''; end
def NE_zip; ''; end
def NE_number_emp_transferred; ''; end
def NE_number_emp_retained; ''; end
def NE_est_mo_wages; ''; end
def NE_est_state_wh_tax; ''; end
def NH_pred_unemp_acct_number; ''; end
def NH_succ_unemp_acct_number; ''; end
def NH_pred_wh_acct_number; ''; end
def NH_address1; ''; end
def NH_city; ''; end
def NH_zip; ''; end
def NH_number_emp_transferred; ''; end
def NH_number_emp_retained; ''; end
def NH_est_mo_wages; ''; end
def NH_est_state_wh_tax; ''; end
def NJ_pred_unemp_acct_number; ''; end
def NJ_succ_unemp_acct_number; ''; end
def NJ_pred_wh_acct_number; ''; end
def NJ_address1; ''; end
def NJ_city; ''; end
def NJ_zip; ''; end
def NJ_number_emp_transferred; ''; end
def NJ_number_emp_retained; ''; end
def NJ_est_mo_wages; ''; end
def NJ_est_state_wh_tax; ''; end
def NM_pred_unemp_acct_number; ''; end
def NM_succ_unemp_acct_number; ''; end
def NM_pred_wh_acct_number; ''; end
def NM_address1; ''; end
def NM_city; ''; end
def NM_zip; ''; end
def NM_number_emp_transferred; ''; end
def NM_number_emp_retained; ''; end
def NM_est_mo_wages; ''; end
def NM_est_state_wh_tax; ''; end
def NV_pred_unemp_acct_number; ''; end
def NV_succ_unemp_acct_number; ''; end
def NV_pred_wh_acct_number; ''; end
def NV_address1; ''; end
def NV_city; ''; end
def NV_zip; ''; end
def NV_number_emp_transferred; ''; end
def NV_number_emp_retained; ''; end
def NV_est_mo_wages; ''; end
def NV_est_state_wh_tax; ''; end
def NY_pred_unemp_acct_number; ''; end
def NY_succ_unemp_acct_number; ''; end
def NY_pred_wh_acct_number; ''; end
def NY_address1; ''; end
def NY_city; ''; end
def NY_zip; ''; end
def NY_number_emp_transferred; ''; end
def NY_number_emp_retained; ''; end
def NY_est_mo_wages; ''; end
def NY_est_state_wh_tax; ''; end
def OH_pred_unemp_acct_number; ''; end
def OH_succ_unemp_acct_number; ''; end
def OH_pred_wh_acct_number; ''; end
def OH_address1; ''; end
def OH_city; ''; end
def OH_zip; ''; end
def OH_number_emp_transferred; ''; end
def OH_number_emp_retained; ''; end
def OH_est_mo_wages; ''; end
def OH_est_state_wh_tax; ''; end
def OK_pred_unemp_acct_number; ''; end
def OK_succ_unemp_acct_number; ''; end
def OK_pred_wh_acct_number; ''; end
def OK_address1; ''; end
def OK_city; ''; end
def OK_zip; ''; end
def OK_number_emp_transferred; ''; end
def OK_number_emp_retained; ''; end
def OK_est_mo_wages; ''; end
def OK_est_state_wh_tax; ''; end
def OR_pred_unemp_acct_number; ''; end
def OR_succ_unemp_acct_number; ''; end
def OR_pred_wh_acct_number; ''; end
def OR_address1; ''; end
def OR_city; ''; end
def OR_zip; ''; end
def OR_number_emp_transferred; ''; end
def OR_number_emp_retained; ''; end
def OR_est_mo_wages; ''; end
def OR_est_state_wh_tax; ''; end
def PA_pred_unemp_acct_number; ''; end
def PA_succ_unemp_acct_number; ''; end
def PA_pred_wh_acct_number; ''; end
def PA_address1; ''; end
def PA_city; ''; end
def PA_zip; ''; end
def PA_number_emp_transferred; ''; end
def PA_number_emp_retained; ''; end
def PA_est_mo_wages; ''; end
def PA_est_state_wh_tax; ''; end
def PR_pred_unemp_acct_number; ''; end
def PR_succ_unemp_acct_number; ''; end
def PR_pred_wh_acct_number; ''; end
def PR_address1; ''; end
def PR_city; ''; end
def PR_zip; ''; end
def PR_number_emp_transferred; ''; end
def PR_number_emp_retained; ''; end
def PR_est_mo_wages; ''; end
def PR_est_state_wh_tax; ''; end
def RI_pred_unemp_acct_number; ''; end
def RI_succ_unemp_acct_number; ''; end
def RI_pred_wh_acct_number; ''; end
def RI_address1; ''; end
def RI_city; ''; end
def RI_zip; ''; end
def RI_number_emp_transferred; ''; end
def RI_number_emp_retained; ''; end
def RI_est_mo_wages; ''; end
def RI_est_state_wh_tax; ''; end
def SC_pred_unemp_acct_number; ''; end
def SC_succ_unemp_acct_number; ''; end
def SC_pred_wh_acct_number; ''; end
def SC_address1; ''; end
def SC_city; ''; end
def SC_zip; ''; end
def SC_number_emp_transferred; ''; end
def SC_number_emp_retained; ''; end
def SC_est_mo_wages; ''; end
def SC_est_state_wh_tax; ''; end
def SD_pred_unemp_acct_number; ''; end
def SD_succ_unemp_acct_number; ''; end
def SD_pred_wh_acct_number; ''; end
def SD_address1; ''; end
def SD_city; ''; end
def SD_zip; ''; end
def SD_number_emp_transferred; ''; end
def SD_number_emp_retained; ''; end
def SD_est_mo_wages; ''; end
def SD_est_state_wh_tax; ''; end
def TN_pred_unemp_acct_number; ''; end
def TN_succ_unemp_acct_number; ''; end
def TN_pred_wh_acct_number; ''; end
def TN_address1; ''; end
def TN_city; ''; end
def TN_zip; ''; end
def TN_number_emp_transferred; ''; end
def TN_number_emp_retained; ''; end
def TN_est_mo_wages; ''; end
def TN_est_state_wh_tax; ''; end
def TX_pred_unemp_acct_number; ''; end
def TX_succ_unemp_acct_number; ''; end
def TX_pred_wh_acct_number; ''; end
def TX_address1; ''; end
def TX_city; ''; end
def TX_zip; ''; end
def TX_number_emp_transferred; ''; end
def TX_number_emp_retained; ''; end
def TX_est_mo_wages; ''; end
def TX_est_state_wh_tax; ''; end
def UT_pred_unemp_acct_number; ''; end
def UT_succ_unemp_acct_number; ''; end
def UT_pred_wh_acct_number; ''; end
def UT_address1; ''; end
def UT_city; ''; end
def UT_zip; ''; end
def UT_number_emp_transferred; ''; end
def UT_number_emp_retained; ''; end
def UT_est_mo_wages; ''; end
def UT_est_state_wh_tax; ''; end
def VA_pred_unemp_acct_number; ''; end
def VA_succ_unemp_acct_number; ''; end
def VA_pred_wh_acct_number; ''; end
def VA_address1; ''; end
def VA_city; ''; end
def VA_zip; ''; end
def VA_number_emp_transferred; ''; end
def VA_number_emp_retained; ''; end
def VA_est_mo_wages; ''; end
def VA_est_state_wh_tax; ''; end
def VI_pred_unemp_acct_number; ''; end
def VI_succ_unemp_acct_number; ''; end
def VI_pred_wh_acct_number; ''; end
def VI_address1; ''; end
def VI_city; ''; end
def VI_zip; ''; end
def VI_number_emp_transferred; ''; end
def VI_number_emp_retained; ''; end
def VI_est_mo_wages; ''; end
def VI_est_state_wh_tax; ''; end
def VT_pred_unemp_acct_number; ''; end
def VT_succ_unemp_acct_number; ''; end
def VT_pred_wh_acct_number; ''; end
def VT_address1; ''; end
def VT_city; ''; end
def VT_zip; ''; end
def VT_number_emp_transferred; ''; end
def VT_number_emp_retained; ''; end
def VT_est_mo_wages; ''; end
def VT_est_state_wh_tax; ''; end
def WA_pred_unemp_acct_number; ''; end
def WA_succ_unemp_acct_number; ''; end
def WA_pred_wh_acct_number; ''; end
def WA_address1; ''; end
def WA_city; ''; end
def WA_zip; ''; end
def WA_number_emp_transferred; ''; end
def WA_number_emp_retained; ''; end
def WA_est_mo_wages; ''; end
def WA_est_state_wh_tax; ''; end
def WI_pred_unemp_acct_number; ''; end
def WI_succ_unemp_acct_number; ''; end
def WI_pred_wh_acct_number; ''; end
def WI_address1; ''; end
def WI_city; ''; end
def WI_zip; ''; end
def WI_number_emp_transferred; ''; end
def WI_number_emp_retained; ''; end
def WI_est_mo_wages; ''; end
def WI_est_state_wh_tax; ''; end
def WV_pred_unemp_acct_number; ''; end
def WV_succ_unemp_acct_number; ''; end
def WV_pred_wh_acct_number; ''; end
def WV_address1; ''; end
def WV_city; ''; end
def WV_zip; ''; end
def WV_number_emp_transferred; ''; end
def WV_number_emp_retained; ''; end
def WV_est_mo_wages; ''; end
def WV_est_state_wh_tax; ''; end
def WY_pred_unemp_acct_number; ''; end
def WY_succ_unemp_acct_number; ''; end
def WY_pred_wh_acct_number; ''; end
def WY_address1; ''; end
def WY_city; ''; end
def WY_zip; ''; end
def WY_number_emp_transferred; ''; end
def WY_number_emp_retained; ''; end
def WY_est_mo_wages; ''; end
def WY_est_state_wh_tax; ''; end
end

class Fcc
 def applicant_middle_initial; ''; end
 def applicant_suffix; ''; end
 def applicant_address; ''; end
 def applicant_po_box; ''; end
 def applicant_city; ''; end
 def applicant_state; ''; end
 def applicant_zip; ''; end
 def applicant_country; ''; end
 def applicant_frn; ''; end
 def applicant_phone; ''; end
 def applicant_fax; ''; end
 def applicant_email; ''; end
 def contact_first_name; ''; end
 def contact_middle_initial; ''; end
 def contact_last_name; ''; end
 def contact_suffix; ''; end
 def contact_entity_name; ''; end
 def contact_address; ''; end
 def contact_po_box; ''; end
 def contact_city; ''; end
 def contact_state; ''; end
 def contact_zip; ''; end
 def contact_phone; ''; end
 def contact_fax; ''; end
 def contact_email; ''; end
 def signatory_first_name; ''; end
 def signatory_middle_initial; ''; end
 def signatory_last_name; ''; end
 def signatory_suffix; ''; end
 def signatory_title; ''; end
 def applicant_first_name; ''; end
 def applicant_last_name; ''; end
 def applicant_entity_name; ''; end
end

# ***** Field Data *****
box1_1 = ''
box1_2 = ''
box1_3 = ''
box2_1 = ''
box2_2 = ''
box2_3 = ''
box2_4 = ''
box2_5 = ''
box2_6 = ''
box2_7 = ''
box2_8 = ''
box2_9 = ''
box2_10 = ''
box2_11 = ''
box2_12 = ''
box2_13 = ''
box2_14 = ''
box2_15 = ''
box2_16 = ''
box2_17 = ''
box2_18 = ''
box2_19 = ''
box2_20 = ''
box2_21 = ''
box2_22 = ''
box2_23 = ''
box2_24 = ''
box2_25 = ''
box2_26 = ''
box2_27 = ''
box2_28 = ''
box2_29 = ''
box2_30 = ''
box2_31 = ''
box2_32 = ''
box2_33 = ''
box2_34 = ''
box2_35 = ''
box2_36 = ''
box2_37 = ''
box2_38 = ''
box2_39 = ''
box2_40 = ''
box2_41 = ''
box2_42 = ''
box2_43 = ''
box2_44 = ''
box2_45 = ''
box2_46 = ''
box2_47 = ''
box2_48 = ''
box2_49 = ''
box2_50 = ''
box2_51 = ''
box2_52 = ''
box2_53 = ''
box2_54 = ''
box2_55 = ''
box2_56 = '1002010Z5'
box2_57 = ''
box3_1 = ''
box3_2 = ''
box3_3 = ''
box3_4 = ''
box3_5 = ''
box3_6 = ''
box3_7 = ''
box3_8 = ''
box3_9 = ''
box3_10 = ''
box3_11 = ''
box3_12 = ''
box3_13 = ''
box3_14 = ''
box3_15 = ''
box3_16 = ''
box3_17 = ''
box3_18 = ''
box3_19 = ''
box3_20 = ''
box3_21 = ''
box3_22 = ''
box3_23 = ''
box3_24 = ''
box3_25 = ''
box3_26 = ''
box3_27 = ''
box3_28 = ''
box3_29 = ''
box3_30 = ''
box3_31 = ''
box3_32 = ''
box3_33 = ''
box3_34 = ''
box3_35 = ''
box3_36 = ''
box3_37 = ''
box3_38 = ''
box3_39 = ''
box3_40 = ''
box3_41 = ''
box3_42 = ''
box3_43 = ''
box3_44 = ''
box3_45 = ''
box3_46 = ''
box3_47 = ''
box3_48 = ''
box3_49 = ''
box3_50 = ''
box3_51 = ''
box3_52 = ''
box3_53 = ''
box3_54 = ''
box3_55 = ''
box3_56 = ''
box3_57 = ''
box3_58 = ''
box3_59 = ''
box3_60 = ''
box3_61 = ''
box3_62 = ''
box3_63 = '1002020Z5'
box3_64 = ''

# ***** Calculations *****

$,="\x02"
$\="\x03\n"

individual = Individual.new
entity = Entity.new

tmp = (individual.business_name.strip.empty? ? "#{individual.first_name} #{individual.middle_initial}  #{individual.last_name} #{individual.suffix}".squeeze(' ') : individual.business_name).strip
print 'box2_51', tmp if !tmp.empty?

if ((individual.business_address.strip + individual.business_address2.strip).empty?)
	addr1 = individual.address.strip
	addr2 = (individual.apartment_number.strip.empty? ? '' : 'Apt. #' + individual.apartment_number).squeeze(' ').strip
	city_state_zip = ((individual.city.strip.empty? ? '' : individual.city + ', ') + individual.state + ' ' + individual.zip).squeeze(' ').strip
else
	addr1 =  individual.business_address.strip
	addr2 = individual.business_address2.strip
	city_state_zip = ((individual.business_city.strip.empty? ? '' : individual.business_city + ', ') + individual.business_state + ' ' + individual.business_zip).squeeze(' ').strip
end

print 'box2_52', addr1 if !addr1.empty?
print 'box2_53', addr2 if !addr2.empty?
print (addr2.empty? ? 'box2_53' : 'box2_54'), city_state_zip if !city_state_zip.empty?



tmp = entity.name.strip
print 'box2_51', tmp if !tmp.empty?

tmp = entity.address.strip
print 'box2_52', tmp if !tmp.empty?

addr2 = entity.address2.strip
print 'box2_53', addr2 if !addr2.empty?

# Using the addr2 variable above will let us check to see if the city, state, zip can go on the 2nd or 3rd line. 
tmp = ((entity.city.strip.empty? ? '' : entity.city + ', ') + entity.state + ' ' + entity.zip).squeeze(' ').strip
print (addr2.empty? ? 'box2_53' : 'box2_54'), tmp if !tmp.empty?

tmp = (case
		when (!individual.business_phone.strip.empty?): individual.business_phone
		when (!individual.work_phone.strip.empty?): individual.work_phone
		when (!individual.phone.strip.empty?): individual.phone
		else individual.mobile_phone
	end).strip
print 'box2_43', tmp if !tmp.empty?

tmp = entity.phone.strip
print 'box2_43', tmp if !tmp.empty?

preparer = Preparer.new

tmp = preparer.phone.strip
print 'box2_45', tmp if !tmp.empty?

#
# End of DataFlow.
#

box2_2 = box1_1
print 'box2_2', box2_2

#
# #################################################################
#
# Processing the Reporting Period for the Due Date and Liability Period calculations.
#
# For Monthly Filers, the Reporting Period is in "MONTH YYYY" format.
# For Quarterly and Anal Filers, the Reporting Period is in "MMM-MMM YYYY" format.
#
# "MMM" is displayed as "JAN" for example, and MONTH is the full spelling of the month name. The Analyst said that
# the month characters should be uppercase for the first letter only. For example "June 20, 2009".
#
# First set the date variable to the entered Reporting Period, if Quarterly or Annual, use the second month.
#
case
	when (box1_1.strip.upcase =~ /\A(JANUARY|FEBRUARY|MARCH|APRIL|MAY|JUNE|JULY|AUGUST|SEPTEMBER|OCTOBER|NOVEMBER|DECEMBER) ((1[7-9]|20)[0-9]{2})\Z/)

		date = Time.gm($2, $1[0,3])

	when (box1_1.strip.upcase =~ /\A(JAN-MAR|APR-JUN|JUL-SEP|OCT-DEC|JAN-DEC) ((1[7-9]|20)[0-9]{2})\Z/)

		date = Time.gm($2, $1[4,3])

	else
		date = nil
end

#
# 
# Due Date and Liability Period Calculations:
#
# The Due Date is the 20th of the month following the end of the Reporting Period in "Month 20, YYYY". format.
#
# The Analyst said that the Due Date for an Annual and Quarterly filer is just as the specs say, the 20th of the
# following month, so a reporting period of "JAN-MAR 2009" would have a due date of "April 20, 2009".
#
# The Liability Period is MMYY where the MM is the two digit value for the last month of the Report Period,
# for example: "JANUARY 2009" would give us "01", "APR-JUN 2009" would give us "06", etc..
#
# The YY portion is the two digit value of the Report Period year minus the century digits. So "APR-JUN 2009"
# would give us "09".
#
# Therefore, "APR-JUN 2009" would give us "0609". A bad Report Period produces "0000".
#
# Also set the liability_period [mmyy] for the scanline.
#
if (date)

	liability_period = "#{date.strftime("%m")}#{date.strftime("%y")}"

	date = Time.gm(date.year + date.month / 12, date.month % 12 + 1)
	box2_49 = "#{date.strftime("%B")} 20, #{date.year}"
else
	box2_49 = ''
	liability_period = "0000"
end

print 'box2_49', box2_49

#
# #################################################################
#

box2_3 = box1_2
print 'box2_3', box2_3

box2_4 = case (box1_3.strip.upcase)
			when ("S"): "SL"
			when ("C"): "CL"
			when ("M"): "ST-2"
			else ""
		end
print 'box2_4', box2_4

box3_1 = box2_1
print 'box3_1', box3_1

box3_2 = box2_2
print 'box3_2', box3_2

#
# Schedule A Deductions:
#

#Note:Per the instructions at the top of Section 1 it says "If no Section 1 deductions, go to Section 2. 
#The total will blank until the user enters data.

#Section 1
if ((box3_3 + box3_4 + box3_5 + box3_6 + box3_7 + box3_8 + box3_9 + box3_10 + box3_11 + box3_12 + box3_13 + box3_14 + box3_15 + box3_16 + box3_17 + box3_19 + box3_21).strip.length > 0)

	box3_22 = '%0.2f' % (box3_3.to_f + box3_4.to_f + box3_5.to_f + box3_6.to_f + box3_7.to_f + box3_8.to_f + box3_9.to_f + box3_10.to_f + box3_11.to_f + box3_12.to_f + box3_13.to_f + box3_14.to_f + box3_15.to_f + box3_16.to_f + box3_17.to_f + box3_19.to_f + box3_21.to_f)
else
	box3_22 = ''
end

print 'box3_22', box3_22


#Section 2

#Note:Per the instructions at the top of Section 2 it says "If no Section 2 deductions, go to Section 3". Each line
#and the total need to blank until the user enters data.

if ((box3_23).strip.length > 0)

	box3_24 = '%0.2f' % (box3_23.to_f * 0.19).round
else
	box3_24 = ''
end

print 'box3_24', box3_24

if ((box3_25).strip.length > 0)

	box3_26 = '%0.2f' % (box3_25.to_f * 0.19).round
else
	box3_26 = ''
end

print 'box3_26', box3_26

if ((box3_27).strip.length > 0)

	box3_28 = '%0.2f' % (box3_27.to_f * 0.215).round
else
	box3_28 = ''
end

print 'box3_28', box3_28

if ((box3_29).strip.length > 0)

	box3_30 = '%0.2f' % (box3_29.to_f * 0.215).round
else
	box3_30 = ''
end

print 'box3_30', box3_30

if ((box3_31).strip.length > 0)

	box3_32 = '%0.2f' % (box3_31.to_f * 0.19).round
else
	box3_32 = ''
end

print 'box3_32', box3_32

if ((box3_33).strip.length > 0)

	box3_34 = '%0.2f' % (box3_33.to_f * 0.2).round
else
	box3_34 = ''
end

print 'box3_34', box3_34

if ((box3_35).strip.length > 0)

	box3_36 = '%0.2f' % (box3_35.to_f * 0.2).round
else
	box3_36 = ''
end

print 'box3_36', box3_36

if ((box3_37).strip.length > 0)

	box3_38 = '%0.2f' % (box3_37.to_f)
else
	box3_38 = ''
end

print 'box3_38', box3_38

if ((box3_39).strip.length > 0)

	box3_40 = '%0.2f' % (box3_39.to_f)
else
	box3_40 = ''
end

print 'box3_40', box3_40

if ((box3_41).strip.length > 0)

	box3_42 = '%0.2f' % (box3_41.to_f)
else
	box3_42 = ''
end

print 'box3_42', box3_42

if ((box3_24 + box3_26 + box3_28 + box3_30 + box3_32 + box3_34 + box3_36 + box3_38 + box3_40 + box3_42 + box3_44).strip.length > 0)

	box3_45 = '%0.2f' % (box3_24.to_f + box3_26.to_f + box3_28.to_f + box3_30.to_f + box3_32.to_f + box3_34.to_f + box3_36.to_f + box3_38.to_f + box3_40.to_f + box3_42.to_f + box3_44.to_f)
else
	box3_45 = ''
end

print 'box3_45', box3_45

box3_46 = '%0.2f' % (box3_22.to_f + box3_45.to_f)
print 'box3_46', box3_46

#
# End Schedule A.
#

#
# Schedule B.
#

#Note 1/9/12:Schedule B (911 Surcharge) is new this year.

if ((box3_48).strip.length > 0)

	box3_49 = '%0.2f' % (box3_48.to_f * 0.07).round
else
	box3_49 = ''
end

print 'box3_49', box3_49

if ((box3_50).strip.length > 0)

	box3_52 = '%0.2f' % (box3_50.to_f * box3_51.to_f).round
else
	box3_52 = ''
end

print 'box3_52', box3_52

box3_53 = '%0.2f' % (box3_49.to_f + box3_52.to_f)
print 'box3_53', box3_53

if ((box3_54).strip.length > 0)

	box3_55 = '%0.2f' % (box3_54.to_f * 0.015).round
else
	box3_55 = ''
end

print 'box3_55', box3_55

if ((box3_56).strip.length > 0)

	box3_58 = '%0.2f' % (box3_56.to_f * box3_57.to_f).round
else
	box3_58 = ''
end

print 'box3_58', box3_58

box3_59 = '%0.2f' % (box3_55.to_f + box3_58.to_f)
print 'box3_59', box3_59

box3_60 = '%0.2f' % (box3_53.to_f + box3_59.to_f)
print 'box3_60', box3_60

box3_62 = '%0.2f' % (box3_60.to_f - box3_61.to_f)
print 'box3_62', box3_62

#
# End Schedule B.
#

box2_7 = box3_46
print 'box2_7', box2_7

box2_8 = '%0.2f' % (box2_6.to_f - box2_7.to_f)
print 'box2_8', box2_8

if ((box2_9 + box2_10).strip.length > 0)

	box2_11 = '%0.2f' % (box2_9.to_f * box2_10.to_f).round
else
	box2_11 = ''
end

print 'box2_11', box2_11

if ((box2_12 + box2_13).strip.length > 0)

	box2_14 = '%0.2f' % (box2_12.to_f * box2_13.to_f).round
else
	box2_14 = ''
end

print 'box2_14', box2_14

if ((box2_15 + box2_18).strip.length > 0)

	box2_16 = '%0.2f' % (box2_15.to_f * 0.0625).round
else
	box2_16 = ''
end

print 'box2_16', box2_16

if ((box2_17 + box2_21).strip.length > 0)

	box2_18 = '%0.2f' % (box2_17.to_f * 0.01).round
else
	box2_18 = ''
end

print 'box2_18', box2_18

if ((box2_19 + box2_20).strip.length > 0)

	box2_21 = '%0.2f' % (box2_19.to_f * box2_20.to_f).round
else
	box2_21 = ''
end

print 'box2_21', box2_21

box2_22 = '%0.2f' % (box2_11.to_f + box2_14.to_f + box2_16.to_f + box2_18.to_f + box2_21.to_f)
print 'box2_22', box2_22

#Note 1/9/12:The note below is still applicable:

#Note 2009:We can longer calc. line 10 as we have no way of knowing if the user paid by the due date. Last year
#the user entered the rate and we could leverage off an entry in that box, but this year the rate is hard coded.

box2_24 = '%0.2f' % (box2_22.to_f - box2_23.to_f)
print 'box2_24', box2_24

if ((box2_25 + box2_31).strip.length > 0)

	box2_26 = '%0.2f' % (box2_25.to_f * 0.0625).round
else
	box2_26 = ''
end

print 'box2_26', box2_26

if ((box2_27 + box2_34).strip.length > 0)

	box2_28 = '%0.2f' % (box2_27.to_f * 0.01).round
else
	box2_28 = ''
end

print 'box2_28', box2_28

box2_31 = '%0.2f' % (box2_26.to_f + box2_28.to_f + box2_30.to_f)
print 'box2_31', box2_31

box2_32 = '%0.2f' % (box2_24.to_f + box2_31.to_f)
print 'box2_32', box2_32

box2_36 = '%0.2f' % (box2_33.to_f + box2_34.to_f + box2_35.to_f)
print 'box2_36', box2_36

box2_37 = '%0.2f' % (box2_32.to_f - box2_36.to_f)
print 'box2_37', box2_37

box2_38 = box3_62
print 'box2_38', box2_38

box2_40 = '%0.2f' % (box2_37.to_f + box2_38.to_f + box2_39.to_f)
print 'box2_40', box2_40

box2_42 = '%0.2f' % (box2_40.to_f - box2_41.to_f)
print 'box2_42', box2_42

box2_48 = box2_2
print 'box2_48', box2_48

#Note:The due date was calculated at the top of the code.

box2_50 = box2_1
print 'box2_50', box2_50

#
# Scanline:
#

#
# This is a pre-existing comment [pre 04/09/09]:
#
# Note 2009:Form changed this year, there is no longer a check box for ST-1 and ST-1/ST-2 form filers.
# Per analyst default to form code 00201 for ST-1 filers.
#
scanline = "00201#{liability_period}1265"

sum = 0
14.downto(2) { |x|
	sum += scanline[14-x, 1].to_i * x
	}

cd = sum % 11	
cd = ( cd < 2 ? cd : 11 - cd )	

ibt = '%08.0f' % (box2_1).delete('-')

box2_55 = "#{scanline}#{cd} #{ibt}"
print 'box2_55', box2_55

#Barcodes
box2_57 = box2_56
print 'box2_57', box2_57

box3_64 = box3_63
print 'box3_64', box3_64
